//+------------------------------------------------------------------+
//|                                        NYBOT Advance/Decline.mq4 |
//|                                      Copyright  2011, LenIFCHIK |
//| /                                               |
//|        .   |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, LenIFCHIK"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 RoyalBlue

extern int Depth=200;                     //     

double ADBuffer[];                        
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name, Tf;
   
   SetIndexBuffer(0,ADBuffer); 
   SetIndexStyle(0,DRAW_LINE);        
                
   if(Period()==1) Tf="M1";
   if(Period()==5) Tf="M5";
   if(Period()==15) Tf="M15";
   if(Period()==30) Tf="M30";
   if(Period()==60) Tf="H1";
   if(Period()==240) Tf="H4";
   if(Period()==1440) Tf="D1";
   if(Period()==10080) Tf="W1";
   if(Period()==43200) Tf="MN";
   short_name="Advance/Decline("+Depth+","+Tf+")";
   IndicatorShortName(short_name);                      

   SetIndexDrawBegin(0,Bars-Depth);   
     
   IndicatorDigits(0);
   return(0);
  }

//----       
int adv(string symbol,int i)
      {
         if(symbol=="EURUSD" || symbol=="GBPUSD")
            {
               if (iClose(symbol,Period(),i)<iClose(symbol,Period(),i+1))                    
                  {
                     int a=1;                                                 
                  }
               else                                                                 
                  {
                     a=0;                                              
                  }       
            }
         else
            {
               if (iClose(symbol,Period(),i)>iClose(symbol,Period(),i+1))                    
                  {
                     a=1;                                                 
                  }
               else                                                                 
                  {
                     a=0;                                              
                  }             
            }
         return(a);      
      }

//----        
int dec(string symbol,int i)
      {
         if(symbol=="EURUSD" || symbol=="GBPUSD")
            {
               if (iClose(symbol,Period(),i)>iClose(symbol,Period(),i+1))                    
                  {
                     int d=1;                                                 
                  }
               else                                                                 
                  {
                     d=0;                                              
                  }       
            }
         else
            {
               if (iClose(symbol,Period(),i)<iClose(symbol,Period(),i+1))                    
                  {
                     d=1;                                                 
                  }
               else                                                                 
                  {
                     d=0;                                              
                  }             
            }
         return(d);      
      }

//+------------------------------------------------------------------+
//| Advance/Decline                                                  |
//+------------------------------------------------------------------+
int start()
  {
   int i,counted_bars=IndicatorCounted(),TimeFrame=Period();
   if(Bars<=Depth) return(0);
   if(counted_bars<1)
      {   
         for(i=1;i<=Depth;i++) ADBuffer[Bars-i]=0.0;
      }
   i=Bars-Depth-1;
   if(counted_bars>=Depth) i=Bars-counted_bars-1;         
   while(i>=0)
      {  
         int Adv=adv("EURUSD",i)+adv("GBPUSD",i)+adv("USDCHF",i)+adv("USDJPY",i)+adv("USDCAD",i)+adv("USDSEK",i);
         int Dec=adv("EURUSD",i)+dec("GBPUSD",i)+dec("USDCHF",i)+dec("USDJPY",i)+dec("USDCAD",i)+dec("USDSEK",i);          
         if(Symbol()=="EURUSD" || Symbol()=="GBPUSD" || Symbol()=="AUDUSD" || Symbol()=="NZDUSD") // ,    
            {
               //   ,    " "
               ADBuffer[i]=ADBuffer[i+1]-Adv+Dec;         
            }
         else
            {
               //   ,    
               ADBuffer[i]=ADBuffer[i+1]+Adv-Dec;         
            }         
         i--;
      }               
   return(0);
  }
//+------------------------------------------------------------------+